<?php

/*************************************************************************
 *
 * CLASS: iSession
 *
 * Description: Session handling
 *
 *************************************************************************/

class iSession
{
// configuration variables (private)

var $time2live = 3600;

// private class variables

var $sid, $session_info, $changed = false;

// class functions

/*********************************************
 *            iSession Constructor
 *********************************************/

function iSession()
{
$in_sid = 0;

if (isset($_REQUEST['sid']) && $this->valid_sid($_REQUEST['sid']))
{
    $in_sid = $_REQUEST['sid'];
}

$this->sid = $this->session_start($in_sid);

$time2live = time() + $this->time2live;

setcookie ("sid", $this->sid, $time2live);

$this->session_info = $this->read_session();
}

/*********************************************
 *              valid_sid
 *********************************************/

function valid_sid ($sid)
{
$sid = trim($sid);

if (empty($sid))
{
    return false;
}

if (!ereg("^[0-9]{1,11}$", $sid))
{
    return false;
}

return true;
}

/*********************************************
 *              session_start
 *********************************************/

function session_start ($sid = 0)
{

$user_ip = $_SERVER['REMOTE_ADDR'];

$user_agent = substr($_SERVER['HTTP_USER_AGENT'],0,255);

$this->cleanup_sessions();

$sq = "SELECT user_ip, user_agent
       FROM `sessions`
       WHERE ses_id='".$sid."'
       LIMIT 0, 1";
$sesinfo = $this->query ($sq);

if (!empty($sesinfo[0]))
{
    if ($sesinfo[0]['user_ip']==$user_ip && $sesinfo[0]['user_agent']==$user_agent)
    {
        // the session exists and we have the same IP and agent so we accept the session id

        $this->sid = $sid;
        return $sid;
    }
}

// try to reuse existing session (only if user is not logged in!)

$sq = "SELECT ses_id
       FROM `sessions`
       WHERE user_ip='".$ip."' AND user_agent='".substr($_SERVER['HTTP_USER_AGENT'],0,255)."'
AND logged_in=0
       LIMIT 0, 1";
$sesinfo = $this->query ($sq);

if (isset($sesinfo[0]['id']))
{
    // everything ok, reuse the session

    $this->sid = $sesinfo[0]['ses_id'];
    return $sesinfo[0]['ses_id'];
}

// no match so we have to create a new session

$this->sid = $this->create_session();
return $this->sid;
}

/*********************************************
 *              cleanup_sessions
 *********************************************/

function cleanup_sessions ()
{
$time2live = time() - $this->time2live;

$sq = "DELETE FROM `sessions`
       WHERE last_time<".$time2live;
$this->query($sq);
}

/*********************************************
 *                 query
 *********************************************/

function query ($sq)
{
global $sql;
return $sql->query($sq);
}

/*********************************************
 *              create_session
 *********************************************/

function create_session ()
{
$tm = time();

// generate a new session id

do
{
    $sid = $this->random_number(100000, 10000000-1);
} while ($this->session_exists($ses_id));

$sq = "INSERT INTO `sessions`
    (ses_id, start_time, last_time, user_ip, user_agent)
    VALUES
    ('".$sid."', '".$tm."', '".$tm."', '".$_SERVER['REMOTE_ADDR']."',
'".substr($_SERVER['HTTP_USER_AGENT'],0,255)."')";
$this->query($sq);

return $sid;
}

/*********************************************
 *              session_exists
 *********************************************/

function session_exists ($sid)
{
$sq = "SELECT ses_id
    FROM `sessions`
    WHERE ses_id='".$sid."'
    LIMIT 0, 1";
$ses_exist = $this->query($sq);

if (!isset($ses_exist[0]['ses_id']))
{
    return false;
}
return true;
}
function random_number ($min, $max)
{
return mt_rand($min,$max);
}


/*********************************************
 *              session_end
 *********************************************/

function session_end ()
{
$this->update_session();
}

/*********************************************
 *              update_session
 *********************************************/

function update_session ()
{
$param = "";

if ($this->changed)
{
    $param = "";
 
    reset ($this->session_info);
    while (list ($key, $val) = each ($this->session_info))
    {
        // skip the id field and last_time

        if ($key!="id" && $key!="last_time")
        {
            $param .= ", ".$key."='".$val."'";
        }
    }

}

$sq = "UPDATE `sessions`
       SET last_time='".time()."'".$param."
       WHERE ses_id='".$this->sid."'
       LIMIT 1";
$this->query($sq);
}

/*********************************************
 *              read_session
 *********************************************/

function read_session ()
{
$sq = "SELECT *
       FROM `sessions`
       WHERE ses_id='".$this->sid."'
       LIMIT 0, 1";
$sesinfo = $this->query($sq);

return $sesinfo[0];
}

/*********************************************
 *              get_var
 *********************************************/

function get_var ($var)
{
return $this->session_info[$var];
}
function mod_var ($var, $val, $immediate = false)
{
$this->changed = true;
$this->session_info[$var] = $val;

if ($immediate)
{
    $this->update_session();
}
}



}
?>